package com.ruoyi.web.v3.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.web.v3.entity.HbCheckAsfEntity;
import com.ruoyi.web.v3.mapper.HbCheckAsfMapper;
import com.ruoyi.web.v3.model.request.HbCheckAsfPageReq;
import com.ruoyi.web.v3.service.IHbCheckAsfService;
import com.ruoyi.web.v3.utils.QueryWrapperBuildUtil;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Arrays;

import static com.ruoyi.common.core.domain.AjaxResult.error;
import static com.ruoyi.common.core.domain.AjaxResult.success;

/**
 * <p>
 * v3.0非洲猪瘟检测登记 服务实现类
 * </p>
 *
 */
@Service
public class HbCheckAsfServiceImpl extends ServiceImpl<HbCheckAsfMapper, HbCheckAsfEntity> implements IHbCheckAsfService {

    @Transactional
    @Override
    public AjaxResult add(HbCheckAsfEntity request) {
        //入参检测
        if(ObjectUtils.isEmpty(request.getQuantity())) {
            return error("请输入【检测生猪数】！");
        }
        //防重检测
        Long count = lambdaQuery().eq(HbCheckAsfEntity::getSampleNoGroup, request.getSampleNoGroup())
                .eq(HbCheckAsfEntity::getAnimalCertNo, request.getAnimalCertNo()).count();
        if (count != 0) {
            return error("请勿重复添加！");
        }
        //自动处理【检测报告编号】
        if(ObjectUtils.isEmpty(request.getRecordId())) {
            request.setRecordId(LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyyMMdd")));
        }
        //自动处理【混样记录】编号
        request.setMixedRecord(request.getAnimalCertNo()+request.getSampleNoGroup());
        return success("添加成功", baseMapper.insert(request));
    }

    @Transactional
    @Override
    public AjaxResult edit(HbCheckAsfEntity request) {
        //数据格式校验
        if(ObjectUtils.isEmpty(request.getId())){
            return error("待更新数据未传入有效ID，请设置数据的唯一标识ID！");
        }
        //根据数据的id更新所有不为空的字段
        return updateById(request) ? success("修改成功！") : error("修改失败，请重试！");
    }

    @Transactional
    @Override
    public AjaxResult delete(String ids) {
        String[] idList = ids.split(",");
        return success("删除成功", removeByIds(Arrays.asList(idList)));
    }

    @Override
    public AjaxResult page(HbCheckAsfPageReq request) {
        //将请求报文转为实体类
        HbCheckAsfEntity entity = BeanUtil.toBean(request, HbCheckAsfEntity.class);
        //构造查询条件（检索条件未定时，先按不为空的字段进行等值查询）
        QueryWrapper<HbCheckAsfEntity> wrapper = QueryWrapperBuildUtil.notNoneEqWrapperHelper(entity);
        wrapper.lambda().orderByDesc(HbCheckAsfEntity::getId);
        return success(baseMapper.selectPage(request.toPage(), wrapper));
    }

    @Override
    public AjaxResult listAll() {
        return success(lambdaQuery().orderByDesc(HbCheckAsfEntity::getId).list());
    }
}
